Subject: Re: [PATCH kernel] KVM: PPC: Fix incorrect guest-to-user-translation error handling

From: Michael Ellerman <[email-masked]>
Date: Mon, 2 Sep 2019 13:06:14 +1000 (AEST)

On Mon, 2019-08-26 at 04:55:20 UTC, Alexey Kardashevskiy wrote:
> H_PUT_TCE_INDIRECT handlers receive a page with up to 512 TCEs from
> a guest. Although we verify correctness of TCEs before we do anything
> with the existing tables, there is a small window when a check in
> kvmppc_tce_validate might pass and right after that the guest alters
> the page with TCEs which can cause early exit from the handler and
> leave srcu_read_lock(&vcpu->kvm->srcu) (virtual mode) or lock_rmap(rmap)
> (real mode) locked.
> 
> This fixes the bug by jumping to the common exit code with an appropriate
> unlock.
> 
> Fixes: 121f80ba68f1 ("KVM: PPC: VFIO: Add in-kernel acceleration for VFIO")
> Signed-off-by: Alexey Kardashevskiy <[email-masked]>

Applied to powerpc topic/ppc-kvm, thanks.

https://git.kernel.org/powerpc/c/4f916593be9da38c5cf0d3a5c386b57beb70f422

cheers